USES Dos, Crt,
     GUtils, GAnsi;

CONST
  ClsBegin  : Boolean = True;
  PauseEnd  : Boolean = True;

TYPE
  PArray    = ^TArray;
  TArray    = ARRAY[1..65000] OF Char;

VAR
  Files       : SearchRec;

  Key         : Word;

  InFile      : FILE;
  InBuffer    : PArray;
  InBufferLen : Word;
  OutFile     : Text;
  OutFileBuf  : PArray;



PROCEDURE OpenInFile(Name:STRING);
VAR IO:Byte;
BEGIN
  Assign(InFile,Name);
  {$I-}
    Reset(InFile,1);
  {$I+}
  IO := IOResult;
  IF IO <> 0 THEN
  BEGIN
    Writeln('Error #',IO,' on file ',Name);
    Halt;
  END;
  {$I-}
  BlockRead(InFile,InBuffer^,SizeOf(InBuffer^),InBufferLen);
  Close(InFile);
  {$I+}
END;


PROCEDURE OpenOutFile(Name:STRING);
VAR IO:Byte;
BEGIN
  Assign(OutFile,Name);
  SetTextBuf(OutFile,OutFileBuf^,SizeOf(OutFileBuf^));
  {$I-}
    Rewrite(OutFile);
  {$I+}
  IO := IOResult;
  IF IO <> 0 THEN
  BEGIN
    Writeln('Error #',IO,' on file ',Name);
    Halt;
  END;
END;

PROCEDURE CloseOutFile;
BEGIN
  Flush(OutFile);
  Close(OutFile);
END;



PROCEDURE ShowFile;
VAR Index:Word;
BEGIN
  FOR Index := 1 TO InBufferLen DO
    ANSIWrite(InBuffer^[Index]);
  TextAttr := 7;
END;

PROCEDURE SaveFile;
VAR I:Integer; Lines:Byte; Scr:ARRAY[1..25] OF STRING[80];
BEGIN
  Lines := 0;
  FOR I := 1 TO 25 DO
    Scr[I] := StripRight(GetScreenStr(1,80,I),' ');
  Lines := 25;
  WHILE (Scr[Lines] = '') OR (Lines=0) DO Dec(Lines);
  IF Lines > 0 THEN
  BEGIN
    IF ClsBegin THEN Write(OutFile,#12);
    FOR I := 1 TO Pred(Lines) DO Writeln(OutFile,Scr[I]);
    Write(OutFile,Scr[Lines]);
    IF PauseEnd THEN Write(OutFile,#01);
  END;
END;



BEGIN
  New(InBuffer);
  New(OutFileBuf);
  TextAttr := 7;
  ClrScr(7);
  Writeln('ANS2ASC CONVERTOR by The GodFather');
  Writeln;
  Write('Convert all ANSI files to ASCII (Y/N): ');
  REPEAT Key := GetKey; UNTIL Chr(Key) IN ['Y','N','y','n'];
  Writeln(Chr(Key));
  IF Chr(Key) IN ['N','n'] THEN Exit;

  Write('Clear screen in ASCII files (Y/N): ');
  REPEAT Key := GetKey; UNTIL Chr(Key) IN ['Y','N','y','n'];
  Writeln(Chr(Key));
  IF Chr(Key) IN ['N','n'] THEN ClsBegin := False;

  Write('Add '#01' at the end of ASCII files (Y/N): ');
  REPEAT Key := GetKey; UNTIL Chr(Key) IN ['Y','N','y','n'];
  Writeln(Chr(Key));
  IF Chr(Key) IN ['N','n'] THEN PauseEnd := False;

  FindFirst('*.ANS',AnyFile AND NOT Directory,Files);
  WHILE DosError = 0 DO
  BEGIN
    OpenInFile(BaseNameOnly(Files.Name)+'.ANS'); ShowFile;
    OpenOutFile(BaseNameOnly(Files.Name)+'.ASC'); SaveFile;
    CloseOutFile;
    FindNext(Files);
  END;
  Dispose(InBuffer);
  Dispose(OutFileBuf);
  TextAttr := 7; Crt.ClrScr;
  Writeln('Everything went OK. Files are converted');
END.