{===========================================================================}
{==                                                                       ==}
{==                         ANSI View Version 4.1                         ==}
{==                 Copyright (C) 1996-97 by The GodFather                ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,128000,655350}   {16Kb Stack, 640Kb Heap}

USES Dos, Crt,
     GUtils, GMemory, GList, GDialogs, GStdDlgs, GAnsi, GErrors;

CONST
  Version    = 'Version 4.1';

  Extension  = 'ANS';


TYPE
  PArray  = ^TArray;
  TArray  = ARRAY[1..64000] OF Char;
  FileStr = STRING[12];

  PFile   = ^TFile;
  TFile   = OBJECT(TObject)
    Name  : PString;
    Size  : LongInt;
    Attr  : Byte;
    Date  : LongInt;
    Dir   : Boolean;
    CONSTRUCTOR Init(AName:FileStr; ASize:LongInt; AAttr:Byte; ADate:LongInt);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PFilesList = ^TFilesList;
  TFilesList = OBJECT(TList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer); VIRTUAL;
  END;

VAR
  Files       : PCollection;
  FilesList   : PFilesList;
  TotalDirs   : Integer;
  TotalFiles  : Integer;
  TotalSize   : LongInt;
  CurrentFile : PFile;
  OrigDir,
  CurrDir,
  OldDir,
  WildCard    : STRING;
  ViewOK      : Boolean;
  _Speed      : Byte;
  _Cursor     : Boolean;
  _Blink      : Boolean;
  Condensed   : Boolean;




{***************************************************************************}
{*************************** LINK OBJECT FILES *****************************}
{***************************************************************************}
PROCEDURE AV_Logo;    EXTERNAL; {$L AV41\AV_LOGO.OBJ}
PROCEDURE AV_Pallete; EXTERNAL; {$L AV41\AV_PAL.OBJ}



{***************************************************************************}
{************************** SET DEFAULT PALLETE ****************************}
{***************************************************************************}
TYPE
  PPallete = ^TPallete;
  TPallete = ARRAY[1..768] OF Byte;

 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 PROCEDURE Pallete(P:PPallete);
 VAR Index:Word;
 BEGIN
   VRetrace;
   Port[$3C8] := 0; {Set first color}
   FOR Index := 1 TO 768 DO Port[$3C9] := P^[Index];
 END;

 PROCEDURE SetDefaultPal;
 BEGIN
   Pallete(@AV_Pallete);
 END;





{***************************************************************************}
{***************************** DRAW MAIN SCREEN ****************************}
{***************************************************************************}
PROCEDURE DrawMainSCREEN;
BEGIN
  ClrScr(7);
  Cursor(Off);
  PosCursor(80,MaxY);
  SetBlink(False);
  SetPAL(AltPAL);
  SetDefaultPal;

  FastWrite(1,1,$0A,PadCenter('ANSIView '+Version,80,' '));
  FastWrite(1,MaxY,$0A,PadCenter('Copyright (C) 1996-97 by The GodFather',80,' '));
  FBox(1,2,49,MaxY-1,$19,Special2);
  FastWrite( 4,2,$1B,' Filename ');
  FastWrite(22,2,$1B,' Size ');
  FastWrite(31,2,$1B,' Date ');
  FastWrite(41,2,$1B,' Time ');
  SmartHLine(1,49,MaxY-4,$19,SingleLine);
  FastWrite (3,MaxY-3,$17,'Total sub-dirs:');
  FastWrite (3,MaxY-2,$17,'Total file(s) :');
  FastWrite(25,MaxY-3,$17,'Wildcard  :');
  FastWrite(25,MaxY-2,$17,'Total size:');

  FBox(51,2,80,15,$5D,Special2);
  SmartHLine(51,80,4,$5D,SingleLine);
  WriteBetween(51,80,3,$5F,'KEYS');
  WriteHi(54, 5,$57,$5E,'    ~F1~   Help');
  WriteHi(54, 6,$57,$5E,'    ~F2~   Blink');
  WriteHi(54, 7,$57,$5E,'    ~F3~   Cursor');
  WriteHi(54, 8,$57,$5E,'    ~F4~   Quiet');
  WriteHi(54, 9,$57,$5E,'    ~F5~   Copy file');
  WriteHi(54,10,$57,$5E,'~TAB F6~   Rename file');
  WriteHi(54,11,$57,$5E,'~DEL F8~   Delete file');
  WriteHi(54,12,$57,$5E,'    ~F9~   About');
  WriteHi(54,13,$57,$5E,'  ~LEFT~   Increase speed');
  WriteHi(54,14,$57,$5E,' ~RIGHT~   Decrease speed');
  SmartVLine(61,4,15,$5D,SingleLine);

  FBox(51,17,80,24,$5D,Special2);
  SmartHLine(51,80,19,$5D,SingleLine);
  WriteBetween(51,80,18,$5F,'PERMANENT OPTIONS');
  WriteHi(52,20,$57,$5E,' ~Speed~     (1)(2)(3)(4)(5)');
  WriteHi(52,21,$57,$5E,' ~Blink~     -YES- -no-');
  WriteHi(52,22,$57,$5E,' ~Cursor~    -yes- -NO-');
  WriteHi(52,23,$57,$5E,' ~Quiet~     -yes- -NO-');
  SmartVLine(61,19,24,$5D,SingleLine);
END;







{***************************************************************************}
{********************************** ABOUT **********************************}
{***************************************************************************}
PROCEDURE About;
VAR OK: PButtons; Y: Byte;
BEGIN
  SaveCursor;
  Cursor(Off);
  Y := MaxY DIV 2 - 9;
  OpenWin(11,Y,60,19,$5D,$5F,Double1,'About');
  WriteBetween(12,70,Y+1,$5A,' ڷ  ڿ ķ                   ');
  WriteBetween(12,70,Y+2,$5A,' ӷ  ķ     ֽ  ķ   ');
  WriteBetween(12,70,Y+3,$5A,' Ķ                 ڿ');
  WriteBetween(12,70,Y+4,$5A,'    Ľ     Ľ   Ľ ');
  WriteBetween(12,70,Y+5,$5E,Version);
  WriteBetween(12,70,Y+6,$5E,'Copyright (C) 1996-97 by The GodFather');
  WriteBetween(12,70,Y+8,$57,'If you have bug-reports, suggestion or comments');
  WriteBetween(12,70,Y+9,$57,'please write to me. I`ll be happy to answer you');
  WriteBetween(12,70,Y+11,$57,' Contact me here: ');
  WriteBetween(12,70,Y+13,$5B,' Email: gf@top.bg ');
  WriteBetween(12,70,Y+14,$5B,' Email: gf@cybcom.net ');
  WriteBetween(12,70,Y+15,$5B,' URL: http://georgi.top.bg/ ');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+17,btDefault);
  OK^.Process;
  Dispose(OK,Done);
  RestoreCursor;
  RmWin;
END;









{***************************************************************************}
{*********************************** HELP **********************************}
{***************************************************************************}
PROCEDURE Help(ViewScreen:Boolean);
VAR UpY,X:Byte; Attr1,Attr2,Attr3,Attr4:Byte;
BEGIN
  Attr1 := $20; Attr2 := $2E;
  Attr3 := $2A; Attr4 := $2F;

  IF ViewScreen THEN
  BEGIN
    Attr1 := $30; Attr2 := $3E;
    Attr3 := $3B; Attr4 := $3F;
  END;

  SaveCursor;
  Cursor(Off);
  UpY := MaxY DIV 2-9;
  X := 28;
  OpenWin(X-10,UpY,50,20,Attr3,Attr4,Double1,'Help');
  WriteHi(X,UpY+3 ,Attr1,Attr2,'   ~F2~   Toggle blink');
  WriteHi(X,UpY+4 ,Attr1,Attr2,'   ~F3~   Toggle cursor');
  WriteHi(X,UpY+5 ,Attr1,Attr2,'   ~F4~   Toggle quiet mode');
  WriteHi(X,UpY+6 ,Attr1,Attr2,'   ~F5~   Copy file');
  WriteHi(X-1,UpY+7 ,Attr1,Attr2,'~TAB~ ~F6~   Rename file');
  WriteHi(X-1,UpY+8 ,Attr1,Attr2,'~DEL~ ~F8~   Delete file');
  IF ViewScreen
    THEN WriteHi(X,UpY+9 ,Attr1,Attr2,'   ~F9~   ReDraw screen')
    ELSE BEGIN
           WriteHi(X,UpY+9 ,Attr1,Attr2,'   ~F9~   About program');
           WriteHi(X,UpY+10,Attr1,Attr2,'  ~F10~   Change drive');
         END;

  WriteHi(X,UpY+11,Attr1,Attr2,'  ~'#27' '#26'~   Decrease, Increase speed');
  WriteHi(X-2,UpY+12,Attr1,Attr2,'~ALT+1-5~   Direct set speed');
  WriteHi(X-2,UpY+13,Attr1,Attr2,' ~ALT+F9~   Change screen lines');
  WriteHi(X-3,UpY+14,Attr1,Attr2,'~CTRL+F10~   File information');
  WriteHi(X-4,UpY+15,Attr1,Attr2,'~SHIFT+F10~   Default options');
  IF ViewScreen
    THEN WriteHi(X,UpY+16,Attr1,Attr2,'  ~ESC~   Exit to file selector')
    ELSE BEGIN
           WriteHi(X,UpY+16,Attr1,Attr2,'  ~ESC~   Exit to current directory');
           WriteHi(X,UpY+17,Attr1,Attr2,'~ALT+X~   Exit to startup directory');
         END;
  Box       (X-6,UpY+2,X+36,UpY+18,Attr3,Single1);
  SmartVLine(X+6,UpY+2,UpY+18,Attr3,SingleLine);
  Pause;
  RmWin;
  RestoreCursor;
END;



{***************************************************************************}
{********************************* COPY FILE *******************************}
{***************************************************************************}
CONST
  DestDirectory : STRING = '';


PROCEDURE CpyFile(ReDrawList:Boolean);
LABEL Again;
VAR FDlg:PDialog; FName:STRING; OK:Boolean; Result:Byte;
    TmpAttr:Word; TmpFile:FILE;
BEGIN
  SaveCursor;
  Cursor(Off);
  FName := PathOnly(DestDirectory)+BaseNameOnly(CurrentFile^.Name^);

  IF CurrentFile^.Dir   THEN Exit;
  IF FName = '..'       THEN Exit;
  IF FName = 'No files' THEN Exit;

 Again:
  OK := False;
  New(FDlg, Init(10,MaxY DIV 2-4,60,9,DefaultDialogPAL,Single1,'Copy file'));
  WITH FDlg^ DO
  BEGIN
    AddTxtInputLine(5,3,'Copy ~'+CurrentFile^.Name^+'~ to:',0,3,4,51,ilFileName,FName);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,15,7,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,35,7,btCancel);
    IF (Process(1) = 1) AND (FName<>'') THEN OK := True;
  END;
  DestDirectory := PathOnly(FName);
  IF BaseNameOnly(FName) = ''
    THEN FName := AddSlash(FExpand(DestDirectory))+Currentfile^.Name^
    ELSE FName := AddSlash(FExpand(DestDirectory))+BaseNameOnly(FName)+'.'+Extension;
  FName := FExpand(FName);

  Dispose(FDlg, Done);
  IF (OK) AND (FExpand(CurrentFile^.Name^) = FName) THEN
  BEGIN
    InfoBox('ERROR: Can''t copy file to itself',True);
    OK := False;
  END;

  IF (OK) AND (Exist(FName)) THEN
  BEGIN
    Result := AltPromptBox('File already exist. Overwrite?',True);
    CASE Result OF
      1: ;
      2: OK := False;
      3: GOTO Again;
    END;
  END;

  IF OK THEN
  BEGIN
    OpenWin(10,MaxY DIV 2-4,60,7,$5D,$5B,Single1,'Copy file');
    WriteBetween(10,70,MaxY DIV 2-2,$57,'Copying');
    WriteBetween(10,70,MaxY DIV 2-1,$5A,FExpand(CurrentFile^.Name^));
    WriteBetween(10,70,MaxY DIV 2-0,$57,'to');
    WriteBetween(10,70,MaxY DIV 2+1,$5A,FName);
    Assign(TMPFile,CurrentFile^.Name^);
    {$I-} GetFAttr(TMPFile,TMPAttr);
          SetFAttr(TMPFile,Archive); {$I+}
    IF IOResult <> 0 THEN ;
    Result := CopyFile(CurrentFile^.Name^,FName);
    {$I-} SetFAttr(TMPFile,TMPAttr); {$I+}
    IF IOResult <> 0 THEN ;
    IF CtrlPressed AND RightShiftPressed THEN Pause;
    VRetrace;
    RmWin;
    CASE Result OF
      1: InfoBox('ERROR: Source and target the same',True);
      2: InfoBox('ERROR: Cannot open source',True);
      3: InfoBox('ERROR: Unable to create target',True);
      4: InfoBox('ERROR: Error during copy',True);
      5: InfoBox('ERROR: Not enough memory',True);
    END;
    IF PathOnly(FName) = PathOnly( FExpand(CurrentFile^.Name^) ) THEN
    BEGIN
      WITH CurrentFile^ DO
      BEGIN
        Files^.Insert(
           New(PFile,
             Init(BaseNameOnly(FName)+'.'+Extension,Size,Attr,Date)));
        IF ReDrawList THEN FilesList^.ChangeMaxTopics(MaxY-7, Files^.Count);
      END;
    END
      ELSE IF ReDrawList THEN FilesList^.ReDraw;
  END;
  RestoreCursor;
END;










{***************************************************************************}
{******************************** RENAME FILE ******************************}
{***************************************************************************}
PROCEDURE RenFile(ReDrawList:Boolean);
VAR FDlg:PDialog; FName:STRING; OK:Boolean; Result:Byte;
BEGIN
  SaveCursor;
  Cursor(Off);
  OK := False;
  FName := BaseNameOnly(CurrentFile^.Name^);
  IF CurrentFile^.Dir   THEN Exit;
  IF FName = '..'       THEN Exit;
  IF FName = 'No files' THEN Exit;
  New(FDlg, Init(16,MaxY DIV 2-4,50,8,DefaultDialogPAL,Single1,'Rename file'));
  WITH FDlg^ DO
  BEGIN
    AddTxtInputLine(15,3,'~F~ile',kbAltF,20,3,8,ilFileName,FName);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,11,6,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,30,6,btCancel);
    IF (Process(1) = 1) AND (FName<>'') THEN OK := True;
  END;
  FName := BaseNameOnly(FName)+'.'+Extension;
  Dispose(FDlg, Done);
  IF OK THEN
  BEGIN
    Result := RenameFile(GetStr(CurrentFile^.Name),FName);
    IF Result = 0
      THEN BEGIN
             SetStr(CurrentFile^.Name, FName);
             IF ReDrawList THEN FilesList^.ReDraw;
           END
      ELSE InfoBox('Error renaming '+CurrentFile^.Name^+' to '+FName,True)
  END;
  RestoreCursor;
END;






{***************************************************************************}
{******************************* DELETE FILE *******************************}
{***************************************************************************}
FUNCTION DelFile(ReDrawList:Boolean):Boolean;
VAR OK:Byte; F:FILE;
BEGIN
  SaveCursor;
  Cursor(Off);
  DelFile := False;
  IF CurrentFile^.Dir THEN Exit;
  IF CurrentFile^.Name^ = 'No files' THEN Exit;
  IF NOT PromptBox('Are you sure you want to delete '+CurrentFile^.Name^+'?',True) THEN Exit;
  OK := DeleteFile(CurrentFile^.Name^);
  IF OK = 0
    THEN BEGIN
           DelFile := True;
           Dec(TotalFiles);
           Files^.AtFree(FilesList^.LSTPosition - 1);
           IF ReDrawList THEN FilesList^.ChangeMaxTopics(MaxY-7, Files^.Count);
         END
    ELSE InfoBox('Error deleting '+CurrentFile^.Name^,True);
  RestoreCursor;
END;


PROCEDURE DefaultOptions;
BEGIN
  _Speed  := 1;
  _Cursor := False;
  _Blink  := True;
  Quiet   := False;
END;


PROCEDURE FileInfo(AFile:PFile);
VAR UpY,X:Byte; Da,Ti:STRING[10]; DT:DateTime;
FUNCTION AZ(A:LongInt): STRING; VAR S:STRING[5]; BEGIN S:=IntToStr(A); IF Length(S) = 1 THEN S:='0'+S; AZ:=S; END;
BEGIN
  IF AFile^.Name^ = '..' THEN Exit;
  IF AFile^.Name^ = 'No files' THEN Exit;
  UpY := MaxY DIV 2 - 5;
  X   := 29;
  UnpackTime(AFIle^.Date, DT);
  WITH DT DO
  BEGIN
    Da := AZ(Day) +'-'+AZ(Month)+'-'+AZ(Year);
    Ti := AZ(Hour)+':'+AZ(Min);
  END;
  OpenWin(X-4,UpY,30,7,$2A,$2F,Single1,'File Information');
  WITH AFile^ DO
  BEGIN
    WriteHi(X,UpY+2,$20,$2E,'Filename: ~'+Name^);
    WriteHi(X,UpY+3,$20,$2E,'    Size: ~'+AddComas(Size));
    WriteHi(X,UpY+4,$20,$2E,'    Date: ~'+Da);
    WriteHi(X,UpY+5,$20,$2E,'    Time: ~'+Ti);
  END;
  Pause;
  RmWin;
END;


{===========================================================================}
{=== TFile OBJECT ==========================================================}
{===========================================================================}
CONSTRUCTOR TFile.Init(AName:FileStr; ASize:LongInt; AAttr:Byte; ADate:LongInt);
BEGIN
  Name := NewStr(AName);
  Size := ASize;
  Attr := AAttr;
  Date := ADate;
  IF (Attr AND Directory) <> 0 THEN Dir := True ELSE Dir := False;
  IF Dir THEN Inc(TotalDirs) ELSE Inc(TotalFiles);
  Inc(TotalSize,Size);
END;

DESTRUCTOR TFile.Done;
BEGIN
  DisposeStr(Name);
  Dec(TotalSize,Size);
END;

FUNCTION FormatFileName(FileName:STRING): STRING;
BEGIN
  IF FileName = '..'
    THEN FormatFileName := PadLeft('..',12,' ')
    ELSE FormatFileName := PadLeft(BaseNameOnly(FileName),8,' ')+' '+
                           PadLeft(ExtOnly(FileName),3,' ');
END;


PROCEDURE ReadFiles;
VAR Dir: SearchRec; Where: STRING;
BEGIN
  TotalSize := 0;
  TotalDirs := 0;
  TotalFiles := 0;
  IF Length(CurrDir) = 3
    THEN Where := CurrDir
    ELSE Where := CurrDir + '\';
  New(Files,Init(1,1));
  FindFirst(Where+'*.*',AnyFile, Dir);
  WHILE DosError = 0 DO
  BEGIN
    IF (Dir.Name <> '.') AND
       ((Dir.Attr AND Directory)<>0)
      THEN Files^.Insert(New(PFile,Init(Dir.Name,0,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read directories}
  FindFirst(Where+WildCard,AnyFile AND NOT (VolumeID OR Directory OR SysFile), Dir);
  WHILE DosError = 0 DO
  BEGIN
    Files^.Insert(New(PFile,Init(Dir.Name,Dir.Size,Dir.Attr,Dir.Time)));
    FindNext(Dir);
    IF MemAvail < 32767 THEN Exit;
  END; {Read files}
  IF Files^.Count  = 0 THEN Files^.Insert(New(PFile,Init('No files',0,0,0)));
END;

PROCEDURE NewDir;
VAR AFile:PFile; I:Integer;
BEGIN
  Dispose(Files,Done);
  ReadFiles;
  WITH FilesList^ DO
  BEGIN
    FilesList^.ChangeMaxTopics(MaxY-7, Files^.Count);
    LSTPosition := 1;
    IF OldDir <> '' THEN
      FOR I := 0 TO Files^.Count-1 DO
      BEGIN
        AFile := Files^.At(I);
        IF AFile^.Name^ = OldDir
          THEN BEGIN
                 LSTPosition := I+1;
                 Break;
               END;
      END;
    ReDraw;
  END;
END;


PROCEDURE ChangeDrive;
LABEL Quit;
VAR ESC:Boolean; Key:Word; Tmp:STRING; UpY:Byte;
BEGIN
  ESC := False;
  UpY := MaxY DIV 2 - 9;
  SaveCursor;
  MkWin(20,UpY+6,42,4,$4C,Special2,'');
  FastWrite(29,UpY+8,$4E,'Enter new drive letter: [ ]');
  FastWrite(54,UpY+8,$4F,CurrDir[1]);
  Cursor(On);
  PosCursor(54,UpY+8);
  Tmp     := '!';
  ClearKBuffer;
  Key     := Ord(UpCase(Chr(GetKey)));
  IF Key = 27 THEN ESC := True;
  IF (Chr(Key) = CurrDir[1]) THEN GOTO Quit;
  IF (Chr(Key) >= 'A') AND (Chr(Key) <= 'Z') THEN Tmp := Chr(Key)+':\';
  IF NOT ESC THEN FastWrite(54,UpY+8,$4F,Tmp[1]);
  {$I-} ChDir(Tmp); {$I+}
  IF IOResult = 0 THEN
  BEGIN
    RmWin;
    RestoreCursor;
    CurrDir := Tmp;
    NewDir;
    Exit;
  END;
Quit:
  RmWin;
  RestoreCursor;
END;

PROCEDURE ExitDir;
VAR TMP: STRING; I: Byte; CH: Char;
BEGIN
  TMP := CurrDir;
  IF Length(TMP) > 3 THEN
  BEGIN
    I      := LastPos('\',TMP);
    OldDir := Copy(TMP,I+1,255);
    Delete(TMP,I,255);
    IF Length(TMP) = 2 THEN TMP := TMP+'\';
    ChDir(TMP);
    CurrDir := TMP;
    NewDir;
  END;
END;

PROCEDURE EnterDir;
VAR TMP:STRING;
BEGIN
  IF NOT CurrentFile^.Dir THEN Exit;
  IF CurrentFile^.Name^ = '..' THEN
  BEGIN
    ExitDir;
    Exit;
  END;
  OldDir := '';
  Tmp    := CurrentFile^.Name^;
  IF Length(CurrDir) = 3
    THEN CurrDir := CurrDir +      TMP
    ELSE CurrDir := CurrDir + '\'+ TMP;
  ChDir(CurrDir);
  NewDir;
END;




{==========================================================}
{======================== VIEW FILE =======================}
{==========================================================}
PROCEDURE ViewAnsiFile(FileName:STRING);
VAR AFile:FILE; I,Readen,Key:Word; Buffer:PArray;
BEGIN
  ViewOK := True;
  SaveFileMode;
  SetFileMode(DenyNone,AccessRead);
  Assign(AFile,FileName);
  {$I-}
    Reset(AFile,1);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    ViewOK := False;
    RestoreFileMode;
    WriteBetween(1,80,MaxY,$0C,'--== ERROR: Can''t open '+FileName+' ==--');
    Pause;
    Exit;
  END;
  New(Buffer);
  REPEAT
    {$I-}
      BlockRead(AFile,Buffer^,SizeOf(Buffer^),Readen);
    {$I+}
    IF IOResult <> 0 THEN
    BEGIN
      ViewOK := False;
      WriteBetween(1,80,MaxY,$0C,'ERROR: Can''t read from '+FileName);
      Pause;
      Break;
    END;
    FOR I := 1 TO Readen DO
    BEGIN
      ANSIWrite(Buffer^[I]);
      IF KeyPressed THEN
      BEGIN
        Key := GetKey;
        IF Key = kbEsc
           THEN BEGIN
                  ViewOK := False;
                  Break;
                END
           ELSE IF Key <> kbEnter THEN
                BEGIN
                  MkWin(1,MaxY,80,1,$07,NoFrame,'');
                  WriteHi(1,MaxY,$0B,$0F,PadCenter('--== Press ~ESC~ to quit or'+
                                  ' any other key to continue ==--',82,' '));
                  ClearKBuffer;
                  Key := GetKey;
                  IF Key = kbEsc THEN
                  BEGIN
                    ViewOK := False;
                    Break;
                  END;
                  ClearKBuffer;
                  RmWin;
                END; {ELSE IF}
      END; {IF}
    END; {FOR}
  UNTIL (Readen <> SizeOf(Buffer^)) OR (ViewOK=False);
  {$I-}
    Close(AFile);
  {$I+}
  RestoreFileMode;
  Dispose(Buffer);
END;


PROCEDURE ViewCurrentAnsiFile;
VAR Key       : Word;
    TimeToQuit: Boolean;
    LocalSpeed: Byte;
    CurrFile  : PFile;
    StartPos,
    CurrPos,
    NumFile   : Integer;
    FileName  : STRING;


 PROCEDURE DrawInfo;
 VAR QU:STRING[2];
 BEGIN
   NumFile := Succ(CurrPos-TotalDirs);
   IF Length(CurrDir) >= 3 THEN Dec(NumFile);
   ClearLine(MaxY,$07);
   WriteHi( 1,MaxY,$07,$0E,'Current: ~'+BaseNameOnly(FileName)+'~');
   WriteHi(19,MaxY,$07,$0F,'Files: ~'+PadRight(IntToStr(NumFile),4,'0')+'~/~'
                                     +PadRight(IntToStr(TotalFiles),4,'0'));
   WriteHi(36,MaxY,$07,$0B,'~'#24#25'~ Prev/Next file ~'#27#26'~ Speed 12345     ~F1~ Help');
   IF Quiet THEN QU := 'X' ELSE QU := ' ';
   FastWrite(69,MaxY,$8F,'*');
   FastWrite(71,MaxY,$0A,QU);
   ClearKBuffer;
 END;

 PROCEDURE ViewFile;
 VAR TmpQuiet:Boolean;
 BEGIN
   TmpQuiet := Quiet;
   InitAnsiWrite;
   Quiet := TmpQuiet;

   ClrScr(7);
   PosCursor(1,1);
   SetBlink(_Blink);
   CASE LocalSpeed OF
     1: DelayNum := 0;
     2: DelayNum := 1;
     3: DelayNum := 4;
     4: DelayNum := 7;
     5: DelayNum := 10;
   END;
   ViewAnsiFile(FileName);
   DrawInfo;
 END;

 PROCEDURE DrawNextFile;
 BEGIN
   FileName   := CurrFile^.Name^;
   LocalSpeed := _Speed;
   ViewFile;
 END;


BEGIN
  TimeToQuit := False;
  LocalSpeed := _Speed;
  StartPos   := FilesList^.LSTPosition;
  CurrPos    := StartPos;

  ClrScr(7);
  PosCursor(1,1);
  SetPal(OrgPAL);
  IF _Cursor THEN Cursor(On);

  CurrFile := Files^.At(FilesList^.LSTPosition-1);
  FileName := CurrFile^.Name^;

  ViewFile;
  DrawInfo;
  REPEAT
    FastWrite(62+LocalSpeed,MaxY,$0F,IntToStr(LocalSpeed));
    Key := GetKey;
    ClearKBuffer;
    CASE Key OF
      kbF1: Help(True);
      kbF2: BEGIN
              _Blink := NOT _Blink;
              SetBlink(_Blink);
            END;
      kbF3: BEGIN
              _Cursor := NOT _Cursor;
              IF _Cursor THEN Cursor(On) ELSE Cursor(Off);
            END;
      kbF4: BEGIN
              Quiet := NOT Quiet;
              DrawInfo;
            END;
      kbF5: BEGIN {COPY FILE}
              SetBlink(False);
              CurrentFile := Files^.At(CurrPos-1);
              CpyFile(False);
              SetBlink(_Blink);
              FileName := CurrentFile^.Name^;
              DrawInfo;
            END;
      kbF6,
     kbTab: BEGIN {RENAME FILE}
              SetBlink(False);
              CurrentFile := Files^.At(CurrPos-1);
              RenFile(False);
              SetBlink(_Blink);
              FileName := CurrentFile^.Name^;
              DrawInfo;
            END;
     kbF8,
     kbDel: BEGIN
              CurrentFile := Files^.At(CurrPos-1);
              FilesList^.LSTPosition := CurrPos;
              SetBlink(False);
              IF DelFile(False) THEN
              BEGIN
                IF Files^.Count = TotalDirs
                  THEN TimeToQuit := True
                  ELSE BEGIN
                         IF CurrPos > Files^.Count
                           THEN CurrPos := Files^.Count;
                         CurrFile := Files^.At(CurrPos-1);
                         DrawNextFile;
                       END;
              END;
              SetBlink(_Blink);
            END;

        kbUp,
      kbPgUp,
      kbHome,
    kbBSpace: IF CurrPos <> TotalDirs+1 THEN
              BEGIN
                IF Key=kbHome
                  THEN CurrPos := TotalDirs+1
                  ELSE Dec(CurrPos);
                CurrFile := Files^.At(CurrPos-1);
                DrawNextFile;
              END ELSE BEGIN
                         SetBlink(False);
                         InfoBox('This is THE FIRST FILE in this directory',TRUE);
                         SetBlink(_Blink);
                      END;
       kbEnd,
      kbPgDn,
      kbDown,
     kbSpace,
     kbEnter: IF CurrPos <> Files^.Count THEN
              BEGIN
                IF Key=kbEnd
                  THEN CurrPos := Files^.Count
                  ELSE Inc(CurrPos);
                CurrFile := Files^.At(CurrPos-1);
                DrawNextFile;
              END ELSE BEGIN
                         SetBlink(False);
                         InfoBox('This is THE LAST FILE in this directory',TRUE);
                         SetBlink(_Blink);
                       END;
        kbF9: ViewFile;

     kbRight: IF LocalSpeed = 5 THEN LocalSpeed := 1 ELSE Inc(LocalSpeed);
      kbLeft: IF LocalSpeed = 1 THEN LocalSpeed := 5 ELSE Dec(LocalSpeed);
      kbAlt1: BEGIN LocalSpeed := 1; ViewFile; END;
      kbAlt2: BEGIN LocalSpeed := 2; ViewFile; END;
      kbAlt3: BEGIN LocalSpeed := 3; ViewFile; END;
      kbAlt4: BEGIN LocalSpeed := 4; ViewFile; END;
      kbAlt5: BEGIN LocalSpeed := 5; ViewFile; END;
       kbEsc: TimeToQuit := True;

     kbAltF9: BEGIN
                ClrScr(7);
                Condensed := NOT Condensed;
                IF Condensed
                  THEN Load8x8
                  ELSE SetVideoMode(StartMode);
                IF _Cursor THEN Cursor(On) ELSE Cursor(Off);
                SetBlink(_Blink);
                SetPal(OrgPal);
                SetDefaultPal;
                {Fixup for stupid CRT unit}
                WindMax := Pred(MaxX) + Pred(MaxY) SHL 8;
                {-------------------------}
                ViewFile;
              END;
   kbCtrlF10: FileInfo(CurrFile);
      kbsF10: BEGIN
                DefaultOptions;
                LocalSpeed := _Speed;
                SetBlink(_Blink);
                IF _Cursor THEN Cursor(On) ELSE Cursor(Off);
                ViewFile;
              END;
    END; {CASE}
    IF (Key=kbLeft) OR (Key=kbRight) THEN ViewFile;
  UNTIL TimeToQuit;

  DrawMainSCREEN;
  FilesList^.LSTPosition := CurrPos;
  FilesList^.FastFindY   := MaxY-4;
  FilesList^.ScrollerY2  := MaxY-5;
  FilesList^.ChangeMaxTopics(MaxY-7, Files^.Count);
END;









{ ----------------------- LIST OBJECT ----------------------- }
PROCEDURE TFilesList.__IdleListCall(ListPos:Integer);
VAR AFile:PFile; Dirs:Integer;
BEGIN
  AFile := Files^.At(ListPos-1);
  CASE _Speed OF
    1: WriteHi(63,20,$57,$5B,'~(1)~(2)(3)(4)(5)');
    2: WriteHi(63,20,$57,$5B,'(1)~(2)~(3)(4)(5)');
    3: WriteHi(63,20,$57,$5B,'(1)(2)~(3)~(4)(5)');
    4: WriteHi(63,20,$57,$5B,'(1)(2)(3)~(4)~(5)');
    5: WriteHi(63,20,$57,$5B,'(1)(2)(3)(4)~(5)~');
  END;
  IF _Blink  THEN WriteHi(63,21,$57,$5A,'-~YES~- -no-') ELSE WriteHi(63,21,$57,$5A,'-yes- -~NO~-');
  IF _Cursor THEN WriteHi(63,22,$57,$5A,'-~YES~- -no-') ELSE WriteHi(63,22,$57,$5A,'-yes- -~NO~-');
  IF  Quiet  THEN WriteHi(63,23,$57,$5A,'-~YES~- -no-') ELSE WriteHi(63,23,$57,$5A,'-yes- -~NO~-');
  Dirs := TotalDirs;
  IF Length(CurrDir) <> 3 THEN Dec(Dirs);
  FastWrite(3,MaxY-1,$19,' '+PadLeft(CurrDir+' ',45,#205));
  FastWrite(19,MaxY-3,$1E,PadLeft(AddComas(Dirs) ,6,' '));
  FastWrite(19,MaxY-2,$1E,PadLeft(AddComas(TotalFiles),6,' '));
  FastWrite(37,MaxY-3,$1E,WildCard);
  FastWrite(37,MaxY-2,$1E,PadLeft(AddComas(TotalSize),12,' '));
END;

FUNCTION TFilesList.__GetLine(ListPos:Integer): STRING;
VAR AFile:PFile; Dt:DateTime; OutStr:STRING; SDate:STRING[20]; DirStr:STRING[9];
FUNCTION AZ(A:LongInt): STRING; VAR S:STRING[5]; BEGIN S:=IntToStr(A); IF Length(S) = 1 THEN S:='0'+S; AZ:=S; END;
BEGIN
  AFile := Files^.At(ListPos-1);
  WITH AFile^ DO
  BEGIN
    DirStr := '<SUB-DIR>';
    IF Name^ = '..' THEN Overwrite(2,DirStr,'UP-');
    IF Dir
      THEN OutStr := FormatFileName(Name^)+PadLeft('   '+DirStr,12,' ')
      ELSE OutStr := FormatFileName(Name^)+PadRight(AddComas(Size),12,' ');
    OutStr := Concat('  ',OutStr);
    UnpackTime(Date, DT);
    WITH DT DO OutStr := OutStr+'  '+AZ(Day) +'-'+AZ(Month)+'-'+AZ(Year)+
                                '  '+AZ(Hour)+':'+AZ(Min);
  END;
  IF AFile^.Name^ = 'No files' THEN OutStr := PadCenter('No files in this directory',49,' ');
  __GetLine := OutStr;
END;


PROCEDURE TFilesList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
BEGIN
  CurrentFile := Files^.At(ListPos-1);
  CASE PressedKey OF
        kbF1: Help(False);
     kbAltF9: BEGIN
                ClrScr(7);
                Condensed := NOT Condensed;
                IF Condensed
                  THEN Load8x8
                  ELSE SetVideoMode(StartMode);
                PosCursor(80,MaxY);
                Cursor(Off);
                SetPal(AltPal);
                SetDefaultPal;
                {Fixup for stupid CRT unit}
                WindMax := Pred(MaxX) + Pred(MaxY) SHL 8;
                {-------------------------}
                DrawMainSCREEN;
                FilesList^.ChangeMaxTopics(MaxY-7, Files^.Count);
                FilesList^.FastFindY  := MaxY-4;
                FilesList^.ScrollerY2 := MaxY-5;
              END;

     kbEnter,
     kbSpace: BEGIN
                IF CurrentFile^.Dir
                  THEN EnterDir
                  ELSE IF (CurrentFile^.Name^ <> 'No files')
                         THEN ViewCurrentAnsiFile;
              END;
     kbBSpace: ExitDir;
        kbF10: ChangeDrive;
       kbAltX,
        kbEsc: BEGIN
                IF PressedKey <> kbEsc THEN
                {$I-}
                  ChDir(OrigDir);
                {$I+}
                EndOfList := True;
               END;
        kbF5: CpyFile(True);
  kbTab,kbF6: RenFile(True);
  kbDel,kbF8: DelFile(True);

     kbRight: IF _Speed = 5 THEN _Speed := 1 ELSE Inc(_Speed);
      kbLeft: IF _Speed = 1 THEN _Speed := 5 ELSE Dec(_Speed);
      kbAlt1: _Speed := 1;
      kbAlt2: _Speed := 2;
      kbAlt3: _Speed := 3;
      kbAlt4: _Speed := 4;
      kbAlt5: _Speed := 5;

kbF2, kbsF2 : _Blink  := NOT _Blink;
kbF3, kbsF3 : _Cursor := NOT _Cursor;
kbF4, kbsF4 : Quiet   := NOT Quiet;
       kbF9 : About;

  kbCtrlF10 : FileInfo(CurrentFile);
     kbsF10 : DefaultOptions;
  END;
END;






{ --------------------------- MAIN ----------------------- }
PROCEDURE ProcessParams;
VAR Param,Param2:STRING; Speed:Byte;
BEGIN
  IF ParamCount = 0 THEN Exit;
  Param  := AdjCase(Upper, ParamStr(1));
  Param2 := AdjCase(Upper, ParamStr(2));
  Speed  := StrToInt(Param2);
  IF (Speed < 1) OR (Speed > 5) THEN Speed := 1;
  IF (Param = '/?') OR
     (Param = '/H') THEN
  BEGIN
    Writeln('ANSIView ',Version);
    Writeln('Copyright (C) 1996-97 by The GodFather');
    Writeln;
    Writeln('   Usage:  AV FileName [Speed]');
    Writeln;
    Writeln('           Speed may vary from 1 to 5');
    Halt;
  END;
  IF ExtOnly(Param) <> ''
    THEN Param := PathOnly(Param)+BaseNameOnly(Param)+'.'+ExtOnly(Param)
    ELSE IF Param[Length(Param)] = '.'
           THEN Param := PathOnly(Param)+BaseNameOnly(Param)
           ELSE Param := PathOnly(Param)+BaseNameOnly(Param)+'.ANS';
  IF NOT Exist(Param) THEN
  BEGIN
    Writeln('ERROR: Can''t find ',Param);
    Halt;
  END;
  Cursor(Off);
  ClrScr(7);
  _Speed := Speed;
  CASE _Speed OF
    1: DelayNum := 0;
    2: DelayNum := 1;
    3: DelayNum := 4;
    4: DelayNum := 7;
    5: DelayNum := 10;
  END;
  ViewANSIFile(Param);
  Cursor(On);
  Halt;
END;




{ ======================================== }
{ ============ MAIN PROGRAM ============== }
{ ======================================== }
BEGIN
  DefaultOptions;
  WildCard  := '*.'+Extension;
  Files     := NIL;
  Condensed := False;

  ProcessParams;

  GetDir(0,OrigDir);
  CurrDir := FExpand(OrigDir);
  ReadFiles;
  DrawMainSCREEN;

  New(FilesList);
  WITH FilesList^ DO
  BEGIN
    Init(2,3,47,MaxY-7,Files^.Count,False,True,3,MaxY-4,#196,True,49,3,MaxY-5,lDefaultPal);
    Process;
  END;

  {-------- EXIT ---------}
  Cursor(Off);
  ClrScr(7);
  SetPal(OrgPal);
  SetBlink(True);
  Dispose(FilesList, Done);
  PosCursor(1,MaxY-2);
  PartRestore(1,(MaxY DIV 2)-11,80,(MaxY DIV 2)+13, @AV_Logo^);
  Cursor(On);
  Halt;
END.
